export interface IBuilder {
    readonly name: string;
    readonly path: string;
}
export declare class Builder {
    private readonly props;
    static new(props: IBuilder): Builder;
    private bespokes;
    private built;
    private forLevel;
    private header;
    private identifiers;
    private ifLevel;
    private indentation;
    private switchCaseLevel;
    private tryLevel;
    private constructor();
    add(content: string): Builder;
    addThenNewline(content: string): Builder;
    await(content: string): Builder;
    awaitThenNewline(content: string): Builder;
    case(check: string): Builder;
    catch(name?: string): Builder;
    default(): Builder;
    else(): Builder;
    elseIf(check: string): Builder;
    endCase(): Builder;
    endFor(): Builder;
    endIf(): Builder;
    endSwitch(): Builder;
    endTry(): Builder;
    ensureOnNewline(): Builder;
    ensureOnNewlineAfterEmptyline(): Builder;
    finally(): Builder;
    for(check: string): Builder;
    getBespokes(): string[];
    getIdentifiers(): string[];
    getName(): string;
    getPath(): string;
    if(check: string): Builder;
    indent(): Builder;
    print(): string;
    return(content: string): Builder;
    returnAwait(content: string): Builder;
    setHeader(header: string): Builder;
    switch(check: string): Builder;
    try(): Builder;
    unindent(): Builder;
    withBespokes(...bespokes: string[]): Builder;
    withIdentifiers(...identifiers: string[]): Builder;
    private _add;
    private _ensureOnNewline;
    private _indent;
    private verify;
}
