import { Builder } from "./builder";
import { NamedRenderer, TRenderer } from "./renderer";
export declare namespace Class {
    interface I {
        readonly content: TRenderer[];
        readonly extends?: string;
        readonly implements?: string[];
        readonly name: string;
        readonly templates?: string[];
    }
    abstract class Base extends NamedRenderer {
        private readonly props;
        private readonly abstract;
        private readonly exported;
        protected constructor(props: I, abstract: boolean, exported: boolean);
        protected render(builder: Builder): void;
        protected verify(builder: Builder): void;
    }
    class Abstract extends Base {
        static newExported(props: I): Abstract;
        static newInternal(props: I): Abstract;
    }
    class Concrete extends Base {
        static newExported(props: I): Concrete;
        static newInternal(props: I): Concrete;
    }
}
