"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Class;
(function (Class) {
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(props, abstract, exported) {
            var _this = _super.call(this) || this;
            _this.props = props;
            _this.abstract = abstract;
            _this.exported = exported;
            return _this;
        }
        Base.prototype.render = function (builder) {
            builder.withIdentifiers(this.props.name);
            if (this.exported) {
                builder.add("export ");
            }
            if (this.abstract) {
                builder.add("abstract ");
            }
            builder.add("class " + this.props.name);
            if (this.props.templates !== undefined) {
                builder.add("<" + this.props.templates.join(", ") + ">");
            }
            builder.add(" ");
            if (this.props["extends"] !== undefined) {
                builder.add("extends " + this.props["extends"] + " ");
            }
            if (this.props.implements !== undefined) {
                builder.add("implements " + this.props.implements.join(", ") + " ");
            }
            builder
                .addThenNewline("{")
                .indent();
            this.props.content
                .forEach(function (content) {
                builder.ensureOnNewlineAfterEmptyline();
                Base.genericRenderer(content)(builder);
            });
            builder
                .unindent()
                .addThenNewline("}");
        };
        Base.prototype.verify = function (builder) {
        };
        return Base;
    }(renderer_1.NamedRenderer));
    Class.Base = Base;
    var Abstract = (function (_super) {
        __extends(Abstract, _super);
        function Abstract() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Abstract.newExported = function (props) {
            return new Abstract(props, true, true);
        };
        Abstract.newInternal = function (props) {
            return new Abstract(props, true, false);
        };
        return Abstract;
    }(Base));
    Class.Abstract = Abstract;
    var Concrete = (function (_super) {
        __extends(Concrete, _super);
        function Concrete() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Concrete.newExported = function (props) {
            return new Concrete(props, false, true);
        };
        Concrete.newInternal = function (props) {
            return new Concrete(props, false, false);
        };
        return Concrete;
    }(Base));
    Class.Concrete = Concrete;
})(Class = exports.Class || (exports.Class = {}));
