import { Builder } from "./builder";
import { NamedRenderer, TRenderer } from "./renderer";
import { Type } from "./type";
export declare namespace Function {
    interface I {
        readonly content: TRenderer[];
        readonly inTypes: Type.Argument[];
        readonly name: string;
        readonly outType: Type.Anonymous;
        readonly templates?: string[];
    }
    abstract class Base extends NamedRenderer {
        private readonly props;
        private readonly async;
        private readonly exported;
        protected constructor(props: I, async: boolean, exported: boolean);
        protected render(builder: Builder): void;
        protected verify(builder: Builder): void;
    }
    class Async extends Base {
        static newExported(props: I): Async;
        static newInternal(props: I): Async;
    }
    class Sync extends Base {
        static newExported(props: I): Sync;
        static newInternal(props: I): Sync;
    }
}
