"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Function;
(function (Function) {
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(props, async, exported) {
            var _this = _super.call(this) || this;
            _this.props = props;
            _this.async = async;
            _this.exported = exported;
            return _this;
        }
        Base.prototype.render = function (builder) {
            builder.withIdentifiers(this.props.name);
            if (this.exported) {
                builder.add("export ");
            }
            if (this.async) {
                builder.add("async ");
            }
            builder.add("function " + this.props.name);
            if (this.props.templates !== undefined) {
                builder.add("<" + this.props.templates.join(", ") + ">");
            }
            builder
                .addThenNewline("(")
                .indent();
            this.props.inTypes.forEach(function (type) {
                type.run(builder);
                builder.addThenNewline(",");
            });
            builder
                .unindent()
                .add("): ");
            this.props.outType.run(builder);
            builder
                .addThenNewline(" {")
                .indent();
            this.props.content
                .forEach(function (content) {
                Base.genericRenderer(content)(builder);
            });
            builder
                .unindent()
                .addThenNewline("}");
        };
        Base.prototype.verify = function (builder) {
        };
        return Base;
    }(renderer_1.NamedRenderer));
    Function.Base = Base;
    var Async = (function (_super) {
        __extends(Async, _super);
        function Async() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Async.newExported = function (props) {
            return new Async(props, true, true);
        };
        Async.newInternal = function (props) {
            return new Async(props, true, false);
        };
        return Async;
    }(Base));
    Function.Async = Async;
    var Sync = (function (_super) {
        __extends(Sync, _super);
        function Sync() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Sync.newExported = function (props) {
            return new Sync(props, false, true);
        };
        Sync.newInternal = function (props) {
            return new Sync(props, false, false);
        };
        return Sync;
    }(Base));
    Function.Sync = Sync;
})(Function = exports.Function || (exports.Function = {}));
