import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
export declare enum EImportKind {
    GLOBAL = 0,
    LOCAL = 1,
    RAW = 2
}
export interface IImportAll {
    readonly name: string;
    readonly withAllAs: string;
}
export interface IImportDefault {
    readonly name: string;
    readonly withDefaultAs: string;
}
export interface IImportRaw {
    readonly name: string;
}
export interface IImportSome {
    readonly name: string;
    readonly with: string[];
}
export declare type TImport = IImportAll | IImportDefault | IImportRaw | IImportSome;
export declare class Import extends NamedRenderer {
    private readonly props;
    static new(props: TImport): Import;
    private constructor();
    compare(i: Import): number;
    kind(): EImportKind;
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
