"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var EImportKind;
(function (EImportKind) {
    EImportKind[EImportKind["GLOBAL"] = 0] = "GLOBAL";
    EImportKind[EImportKind["LOCAL"] = 1] = "LOCAL";
    EImportKind[EImportKind["RAW"] = 2] = "RAW";
})(EImportKind = exports.EImportKind || (exports.EImportKind = {}));
var Import = (function (_super) {
    __extends(Import, _super);
    function Import(props) {
        var _this = _super.call(this) || this;
        _this.props = props;
        return _this;
    }
    Import["new"] = function (props) {
        return new Import(props);
    };
    Import.prototype.compare = function (i) {
        return this.props.name.localeCompare(i.props.name);
    };
    Import.prototype.kind = function () {
        if (Object.keys(this.props).length === 1) {
            return EImportKind.RAW;
        }
        else if (this.props.name.startsWith(".")) {
            return EImportKind.LOCAL;
        }
        else {
            return EImportKind.GLOBAL;
        }
    };
    Import.prototype.render = function (builder) {
        builder.withIdentifiers(this.props.name);
        if ("withAllAs" in this.props) {
            builder.addThenNewline("import * as " + this.props.withAllAs + " from \"" + this.props.name + "\";");
        }
        else if ("withDefaultAs" in this.props) {
            builder.addThenNewline("import " + this.props.withDefaultAs + " from \"" + this.props.name + "\";");
        }
        else if ("with" in this.props) {
            builder
                .addThenNewline("import {")
                .indent();
            this.props["with"]
                .sort(function (a, b) {
                return a.toLowerCase()
                    .localeCompare(b.toLowerCase());
            })
                .forEach(function (name) { builder.addThenNewline(name + ","); });
            builder
                .unindent()
                .addThenNewline("} from \"" + this.props.name + "\";");
        }
        else {
            builder.addThenNewline("import \"" + this.props.name + "\";");
        }
    };
    Import.prototype.verify = function (builder) {
    };
    return Import;
}(renderer_1.NamedRenderer));
exports.Import = Import;
