import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
import { Type } from "./type";
export interface IInterface {
    readonly extends?: string[];
    readonly kind?: string;
    readonly name: string;
    readonly templates?: string[];
    readonly types: Array<Type.FromMethod | Type.Optional | Type.Required>;
}
export declare class Interface extends NamedRenderer {
    private readonly props;
    private readonly exported;
    static newExported(props: IInterface): Interface;
    static newInternal(props: IInterface): Interface;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
