"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Interface = (function (_super) {
    __extends(Interface, _super);
    function Interface(props, exported) {
        var _this = _super.call(this) || this;
        _this.props = props;
        _this.exported = exported;
        return _this;
    }
    Interface.newExported = function (props) {
        return new Interface(props, true);
    };
    Interface.newInternal = function (props) {
        return new Interface(props, false);
    };
    Interface.prototype.render = function (builder) {
        builder.withIdentifiers(this.props.name);
        if (this.exported) {
            builder.add("export ");
        }
        builder.add("interface " + this.props.name);
        if (this.props.templates !== undefined) {
            builder.add("<" + this.props.templates.join(", ") + ">");
        }
        if (this.props["extends"] !== undefined) {
            builder.add(" extends " + this.props["extends"].join(", "));
        }
        builder
            .addThenNewline(" {")
            .indent();
        if ("kind" in this.props) {
            builder.addThenNewline("kind: \"" + this.props.kind + "\";");
        }
        this.props.types.forEach(function (type) {
            type.run(builder);
            builder.addThenNewline(";");
        });
        builder
            .unindent()
            .addThenNewline("}");
    };
    Interface.prototype.verify = function (builder) {
    };
    return Interface;
}(renderer_1.NamedRenderer));
exports.Interface = Interface;
