import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
import { Type } from "./type";
export declare namespace Property {
    enum E {
        PRIVATE = "private",
        PROTECTED = "protected",
        PUBLIC = "public"
    }
    interface I {
        readonly assignment?: string;
        readonly type: Type.Required | Type.Optional;
    }
    abstract class Base extends NamedRenderer {
        private readonly props;
        private readonly readonly;
        private readonly isStatic;
        private readonly kind;
        protected constructor(props: I, readonly: boolean, isStatic: boolean, kind: E);
        protected render(builder: Builder): void;
        protected verify(builder: Builder): void;
    }
    abstract class BaseInstance extends Base {
    }
    namespace Instance {
        class Private extends BaseInstance {
            static newImmutable(props: I): Private;
            static newMutable(props: I): Private;
        }
        class Protected extends BaseInstance {
            static newImmutable(props: I): Protected;
            static newMutable(props: I): Protected;
        }
        class Public extends BaseInstance {
            static newImmutable(props: I): Public;
            static newMutable(props: I): Public;
        }
    }
    abstract class BaseStatic extends Base {
    }
    namespace Static {
        class Private extends BaseStatic {
            static newImmutable(props: I): Private;
            static newMutable(props: I): Private;
        }
        class Protected extends BaseStatic {
            static newImmutable(props: I): Protected;
            static newMutable(props: I): Protected;
        }
        class Public extends BaseStatic {
            static newImmutable(props: I): Public;
            static newMutable(props: I): Public;
        }
    }
}
