"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Property;
(function (Property) {
    var E;
    (function (E) {
        E["PRIVATE"] = "private";
        E["PROTECTED"] = "protected";
        E["PUBLIC"] = "public";
    })(E = Property.E || (Property.E = {}));
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(props, readonly, isStatic, kind) {
            var _this = _super.call(this) || this;
            _this.props = props;
            _this.readonly = readonly;
            _this.isStatic = isStatic;
            _this.kind = kind;
            return _this;
        }
        Base.prototype.render = function (builder) {
            builder.add(this.kind + " ");
            if (this.readonly) {
                builder.add("readonly ");
            }
            if (this.isStatic) {
                builder.add("static ");
            }
            this.props.type.run(builder);
            if (this.props.assignment !== undefined) {
                builder.addThenNewline(" = " + this.props.assignment + ";");
            }
            else {
                builder.addThenNewline(";");
            }
        };
        Base.prototype.verify = function (builder) {
        };
        return Base;
    }(renderer_1.NamedRenderer));
    Property.Base = Base;
    var BaseInstance = (function (_super) {
        __extends(BaseInstance, _super);
        function BaseInstance() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return BaseInstance;
    }(Base));
    Property.BaseInstance = BaseInstance;
    var Instance;
    (function (Instance) {
        var Private = (function (_super) {
            __extends(Private, _super);
            function Private() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Private.newImmutable = function (props) {
                return new Private(props, true, false, E.PRIVATE);
            };
            Private.newMutable = function (props) {
                return new Private(props, false, false, E.PRIVATE);
            };
            return Private;
        }(BaseInstance));
        Instance.Private = Private;
        var Protected = (function (_super) {
            __extends(Protected, _super);
            function Protected() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Protected.newImmutable = function (props) {
                return new Protected(props, true, false, E.PROTECTED);
            };
            Protected.newMutable = function (props) {
                return new Protected(props, false, false, E.PROTECTED);
            };
            return Protected;
        }(BaseInstance));
        Instance.Protected = Protected;
        var Public = (function (_super) {
            __extends(Public, _super);
            function Public() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Public.newImmutable = function (props) {
                return new Public(props, true, false, E.PUBLIC);
            };
            Public.newMutable = function (props) {
                return new Public(props, false, false, E.PUBLIC);
            };
            return Public;
        }(BaseInstance));
        Instance.Public = Public;
    })(Instance = Property.Instance || (Property.Instance = {}));
    var BaseStatic = (function (_super) {
        __extends(BaseStatic, _super);
        function BaseStatic() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return BaseStatic;
    }(Base));
    Property.BaseStatic = BaseStatic;
    var Static;
    (function (Static) {
        var Private = (function (_super) {
            __extends(Private, _super);
            function Private() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Private.newImmutable = function (props) {
                return new Private(props, true, true, E.PRIVATE);
            };
            Private.newMutable = function (props) {
                return new Private(props, false, true, E.PRIVATE);
            };
            return Private;
        }(BaseStatic));
        Static.Private = Private;
        var Protected = (function (_super) {
            __extends(Protected, _super);
            function Protected() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Protected.newImmutable = function (props) {
                return new Protected(props, true, true, E.PROTECTED);
            };
            Protected.newMutable = function (props) {
                return new Protected(props, false, true, E.PROTECTED);
            };
            return Protected;
        }(BaseStatic));
        Static.Protected = Protected;
        var Public = (function (_super) {
            __extends(Public, _super);
            function Public() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Public.newImmutable = function (props) {
                return new Public(props, true, true, E.PUBLIC);
            };
            Public.newMutable = function (props) {
                return new Public(props, false, true, E.PUBLIC);
            };
            return Public;
        }(BaseStatic));
        Static.Public = Public;
    })(Static = Property.Static || (Property.Static = {}));
})(Property = exports.Property || (exports.Property = {}));
