"use strict";
exports.__esModule = true;
var builder_1 = require("./builder");
var NamedRenderer = (function () {
    function NamedRenderer() {
    }
    NamedRenderer.genericRenderer = function (renderer) {
        if (renderer instanceof NamedRenderer) {
            return function (builder) {
                renderer.run(builder);
            };
        }
        else {
            return renderer;
        }
    };
    NamedRenderer.prototype.print = function (builder) {
        var forceBuilder;
        if (builder === undefined) {
            forceBuilder = builder_1.Builder["new"]({
                name: "DO_NOT_COMMIT",
                path: "DO_NOT_COMMIT"
            });
        }
        else {
            forceBuilder = builder;
        }
        this.run(forceBuilder);
        return forceBuilder.print();
    };
    NamedRenderer.prototype.run = function (builder) {
        this.render(builder);
        this.verify(builder);
    };
    return NamedRenderer;
}());
exports.NamedRenderer = NamedRenderer;
