"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Type;
(function (Type) {
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(props, optional) {
            var _this = _super.call(this) || this;
            _this.props = props;
            _this.optional = optional;
            return _this;
        }
        Base.prototype.render = function (builder) {
            if ("name" in this.props) {
                builder.add("" + this.props.name + (this.optional ? "?" : "") + ": ");
            }
            if ("type" in this.props) {
                builder.add(this.props.type);
            }
            else if ("types" in this.props) {
                builder.add(this.props.types.join(" | "));
            }
            else if ("property" in this.props) {
                builder.add(this.props.property
                    .print()
                    .replace(";\n", ""));
            }
            else {
                this.props.method
                    .print()
                    .replace(";\n", "")
                    .replace("public abstract ", "")
                    .replace("public async abstract ", "")
                    .split("\n")
                    .forEach(function (line, idx, arr) {
                    if (idx === arr.length - 1) {
                        builder.add(line);
                    }
                    else {
                        builder.addThenNewline(line);
                    }
                });
            }
            if ("default" in this.props) {
                if (this.props["default"] !== undefined) {
                    builder.add(" = " + this.props["default"]);
                }
            }
        };
        Base.prototype.verify = function (builder) {
        };
        return Base;
    }(renderer_1.NamedRenderer));
    Type.Base = Base;
    var Anonymous = (function (_super) {
        __extends(Anonymous, _super);
        function Anonymous() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Anonymous["new"] = function (props) {
            return new Anonymous(props, false);
        };
        return Anonymous;
    }(Base));
    Type.Anonymous = Anonymous;
    var Argument = (function (_super) {
        __extends(Argument, _super);
        function Argument() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Argument["new"] = function (props) {
            return new Argument(props, false);
        };
        return Argument;
    }(Base));
    Type.Argument = Argument;
    var FromMethod = (function (_super) {
        __extends(FromMethod, _super);
        function FromMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FromMethod["new"] = function (props) {
            return new Argument(props, false);
        };
        return FromMethod;
    }(Base));
    Type.FromMethod = FromMethod;
    var FromProperty = (function (_super) {
        __extends(FromProperty, _super);
        function FromProperty() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FromProperty["new"] = function (props) {
            return new Argument(props, false);
        };
        return FromProperty;
    }(Base));
    Type.FromProperty = FromProperty;
    var Optional = (function (_super) {
        __extends(Optional, _super);
        function Optional() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Optional["new"] = function (props) {
            return new Optional(props, true);
        };
        return Optional;
    }(Base));
    Type.Optional = Optional;
    var Required = (function (_super) {
        __extends(Required, _super);
        function Required() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Required["new"] = function (props) {
            return new Required(props, false);
        };
        return Required;
    }(Base));
    Type.Required = Required;
})(Type = exports.Type || (exports.Type = {}));
